Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.elasticmapreduce
Interface AmazonElasticMapReduceAsync

All Superinterfaces:
  AmazonElasticMapReduce

All Known Implementing Classes:
  AmazonElasticMapReduceAsyncClient

    public interface AmazonElasticMapReduceAsync

extends AmazonElasticMapReduce

Interface for accessing AmazonElasticMapReduce asynchronously, using Java Futures.

This is the Amazon Elastic MapReduce API Reference Guide. This guide is for programmers that need detailed information about the Amazon Elastic MapReduce SOAP and Query APIs.

This document was last updated on May 5, 2010.

Method Summary
`Future<Void>` | `addJobFlowStepsAsync(AddJobFlowStepsRequest addJobFlowStepsRequest)` AddJobFlowSteps adds new steps to a running job flow.
`Future<DescribeJobFlowsResult>` | `describeJobFlowsAsync(DescribeJobFlowsRequest describeJobFlowsRequest)` DescribeJobFlows returns a list of job flows that match all of the supplied parameters.
`Future<RunJobFlowResult>` | `runJobFlowAsync(RunJobFlowRequest runJobFlowRequest)` RunJobFlow creates and starts running a new job flow.
`Future<Void>` | `terminateJobFlowsAsync(TerminateJobFlowsRequest terminateJobFlowsRequest)` TerminateJobFlows shuts a list of job flows down.

Methods inherited from interface com.amazonaws.services.elasticmapreduce.AmazonElasticMapReduce
`addJobFlowSteps, describeJobFlows, describeJobFlows, runJobFlow, setEndpoint, shutdown, terminateJobFlows`

Method Detail

### addJobFlowStepsAsync

    Future<Void> addJobFlowStepsAsync(AddJobFlowStepsRequest addJobFlowStepsRequest)
                                      throws AmazonServiceException,
                                             AmazonClientException

  AddJobFlowSteps adds new steps to a running job flow. The maximum number of steps in a job flow is 256.

  A step specifies the location of a JAR file stored either on the master node of the job flow or in Amazon S3. Each step is performed by the main function of the main class of the JAR file. The main class can be specified either in the manifest of the JAR or by using the MainFunction parameter of the step.

  SElastic MapReduce executes each step in the order listed. For a step to be considered complete, the main function must exit with a zero exit code and all Hadoop jobs started while the step was running must have completed and run successfully.

  You can only add steps to a job flow that is in one of the following states: STARTING, BOOTSTAPPING, RUNNING or WAITING.

  Parameters:
    `addJobFlowStepsRequest` - Container for the necessary parameters to execute the AddJobFlowSteps operation on AmazonElasticMapReduce.
  Returns:
    A Java Future object containing the response from the AddJobFlowSteps service method, as returned by AmazonElasticMapReduce.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonElasticMapReduce indicating either a problem with the data in the request, or a server side issue.

### terminateJobFlowsAsync

    Future<Void> terminateJobFlowsAsync(TerminateJobFlowsRequest terminateJobFlowsRequest)
                                        throws AmazonServiceException,
                                               AmazonClientException

  TerminateJobFlows shuts a list of job flows down. When a job flow is shut down, any step not yet completed is canceled and the EC2 instances on which the job flow is running are stopped. Any log files not already saved are uploaded to Amazon S3 if a LogUri was specified when the job flow was created.

  Parameters:
    `terminateJobFlowsRequest` - Container for the necessary parameters to execute the TerminateJobFlows operation on AmazonElasticMapReduce.
  Returns:
    A Java Future object containing the response from the TerminateJobFlows service method, as returned by AmazonElasticMapReduce.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonElasticMapReduce indicating either a problem with the data in the request, or a server side issue.

### describeJobFlowsAsync

    Future<DescribeJobFlowsResult> describeJobFlowsAsync(DescribeJobFlowsRequest describeJobFlowsRequest)
                                                         throws AmazonServiceException,
                                                                AmazonClientException

  DescribeJobFlows returns a list of job flows that match all of the supplied parameters. The parameters can include a list of job flow IDs, job flow states, and restrictions on job flow creation date and time.

  Regardless of supplied parameters, only job flows created within the last two months are returned.

  If no parameters are supplied, then job flows matching either the following criteria are returned:

  - Job flows created and completed in the last two weeks.
  - Job flows created within the last two months that are in one of the following states: `RUNNING` , `WAITING` , `SHUTTING_DOWN` , `STARTING` .

  Amazon Elastic MapReduce can return a maximum of 512 job flow descriptions.

  Parameters:
    `describeJobFlowsRequest` - Container for the necessary parameters to execute the DescribeJobFlows operation on AmazonElasticMapReduce.
  Returns:
    A Java Future object containing the response from the DescribeJobFlows service method, as returned by AmazonElasticMapReduce.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonElasticMapReduce indicating either a problem with the data in the request, or a server side issue.

### runJobFlowAsync

    Future<RunJobFlowResult> runJobFlowAsync(RunJobFlowRequest runJobFlowRequest)
                                             throws AmazonServiceException,
                                                    AmazonClientException

  RunJobFlow creates and starts running a new job flow. The job flow will run the steps specified. Once the job flow completes, the EC2 cluster is stopped and the HDFS partition is lost. To prevent loss of data, configure the last step of the job flow to store results in Amazon S3. If the JobFlowInstancesDetail : KeepJobFlowAliveWhenNoSteps parameter is set to TRUE, the job flow will transition to the WAITING state rather than shutting down once the steps have completed.

  A maximum of 256 steps are allowed in each job flow.

  For long running job flows, we recommended that you periodically store your results.

  Parameters:
    `runJobFlowRequest` - Container for the necessary parameters to execute the RunJobFlow operation on AmazonElasticMapReduce.
  Returns:
    A Java Future object containing the response from the RunJobFlow service method, as returned by AmazonElasticMapReduce.
  Throws:
    `AmazonClientException` - If any internal errors are encountered inside the client while attempting to make the request or handle the response. For example if a network connection is not available.
    `AmazonServiceException` - If an error response is returned by AmazonElasticMapReduce indicating either a problem with the data in the request, or a server side issue.

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.